C     THIS FILE CONTAINS THE FOLLOWING SUBROUTINES
C     NECESSARY FOR LZW-COMPRESSION:
C
C     SUBROUTINE BF_PACK(CHARSTRING,FROMBIT,NOBIT,VALUE)        
C     CHARACTER*(*) CHARSTRING
C     INTEGER*4 FROMBIT,NOBIT,VALUE
C
C     SUBROUTINE BF_UNPACK(CHARSTRING,FROMBIT,NOBIT,VALUE)        
C     CHARACTER*CHARSTRING
C     INTEGER*4 FROMBIT,NOBIT,VALUE
C
C     THESE SUBROUTINES USE SPECIAL FUNCTIONS WHICH ARE
C     NOT STANDARD FORTRAN. THEY ARE AVAILABLE UNDER
C     SALFORD FORTRAN 77. 
C
C     TRANSLATION FROM THE VMS-VERSION OF ARNE VAJHOJ
C     GRAZ, MAI 1995                  ROBERT HOSCHEK
C                (e-mail: hoschek@igte.tu-graz.ac.at)
      
      SUBROUTINE BF_PACK(CHARSTRING,FROMBIT,NOBIT,VALUE)        
        
      INTRINSIC CORE4
      CHARACTER*(*) CHARSTRING
      INTEGER*4 FROMBIT,NOBIT,VALUE  
      INTEGER*4 FROMIND,FROMOFF  
      INTEGER*4 ADDR, DWORD, IVAL 

      FROMIND=(FROMBIT-1)/8+1  
      FROMOFF=MOD(FROMBIT-1,8)  
C     MOD ... Modulo function
      ADDR=LOC(CHARSTRING(FROMIND:FROMIND))
C     LOC returns a 4-byte address-pointer of the argument     
      DWORD=CORE4(ADDR)
C     CORE4 returns a 4-byte value from memory specified 
C     by the argument as an address-pointer
      DWORD=AND(DWORD,2**FROMOFF-1)
C     AND ... bitwise logical and
      IVAL=LS(VALUE,FROMOFF)
C     LS ... SHIFT LEFT
      DWORD=OR(DWORD,IVAL)
C     OR ... bitwise logical or
      CORE4(ADDR)=DWORD
C     memory specified by the address-pointer-argument 
C     is set to right-side value      
      RETURN
      END

      SUBROUTINE BF_UNPACK(CHARSTRING,FROMBIT,NOBIT,VALUE)        
        
      CHARACTER*(*) CHARSTRING
      INTEGER*4 FROMBIT,NOBIT,VALUE  
      INTEGER*4 FROMIND,FROMOFF,DWORD,ADDR  
        
      FROMIND=(FROMBIT-1)/8+1  
      FROMOFF=MOD(FROMBIT-1,8)  
C     MOD ... Modulo function
      ADDR=LOC(CHARSTRING(FROMIND:FROMIND))
C     LOC returns a 4-byte address-pointer of the argument     
      DWORD=CORE4(ADDR)
C     CORE4 returns a 4-byte value from memory specified 
C     by the argument as an address-pointer
      VALUE=BITS(DWORD,32-FROMOFF-NOBIT+1,32-FROMOFF)
C     BITS ... reads number of bits from an argument
      
      RETURN
      END

