C     THIS FILE CONTAINS THE EXAMPLE SUBROUTINES FOR USING
C     LZW-COMPRESSION:
C
C     SUBROUTINE COMP()        
C     SUBROUTINE EXP()        
C
C     THESE SUBROUTINES USE SPECIAL FUNCTIONS WHICH ARE
C     NOT STANDARD FORTRAN. THEY ARE AVAILABLE UNDER
C     SALFORD FORTRAN 77. 
C
C     THE PROGRAM TST READS A FILE Z1.DAT,
C     USE LZW-COMPRESSION TO WRITE Z2.DAT,
C     FINALLY Z2.DAT IS EXPANDED TO Z3.DAT
C     COMPRESSION RATE IS DISPLAYED
C     
C
C     TRANSLATION FROM THE VMS-VERSION OF ARNE VAJHOJ
C     GRAZ, MAI 1995                  ROBERT HOSCHEK
C                (e-mail: hoschek@igte.tu-graz.ac.at)
      
      PROGRAM TST
      CALL COMP()
      CALL EXP()
      END
C
      SUBROUTINE COMP
      INTEGER*2 IHANDLE,OHANDLE,ERROR_CODE
      INTEGER*4 L,L1,L2,SUM1,SUM2
      CHARACTER*16384 S,S2
      CALL OPENR@('Z1.DAT',IHANDLE,ERROR_CODE)
      CALL OPENW@('Z2.DAT',OHANDLE,ERROR_CODE)
      L=1024
      SUM1=0
      SUM2=0
 100  CALL READF@(S,IHANDLE,L,L1,ERROR_CODE)
      IF(L1.GT.0) THEN
        CALL CMP_COMP_LZW_16BIT(S(1:L1),S2,L2)
        CALL WRITEF@(L2,OHANDLE,4 ,ERROR_CODE) 
        CALL WRITEF@(S2,OHANDLE,L2,ERROR_CODE) 
        SUM1=SUM1+L1
        SUM2=SUM2+L2
        IF(L1.EQ.L) GOTO 100
      ENDIF
      WRITE(*,*) 'Compression: ',REAL(SUM1)/REAL(SUM2)
      WRITE(*,*) 'Reduction(%): ', 100-(REAL(SUM2)/REAL(SUM1)*100)
      CALL CLOSEF@(IHANDLE)
      CALL CLOSEF@(OHANDLE)
      
      RETURN
      END
C
      SUBROUTINE EXP()
      
      INTEGER*2 IHANDLE,OHANDLE,ERROR_CODE
      INTEGER*4 L,L1,L2,SUM1,SUM2
      CHARACTER*16384 S,S2
      CALL OPENR@('Z2.DAT',IHANDLE,ERROR_CODE)
      CALL OPENW@('Z3.DAT',OHANDLE,ERROR_CODE)
      L=1024
      SUM1=0
      SUM2=0
 100  CALL READF@(L,IHANDLE,4,L1,ERROR_CODE)
      CALL READF@(S,IHANDLE,L,L1,ERROR_CODE)
      IF(L1.GT.0) THEN
        CALL CMP_EXP_LZW_16BIT(S(1:L1),S2,L2)
        CALL WRITEF@(S2,OHANDLE,L2,ERROR_CODE) 
        SUM1=SUM1+L1
        SUM2=SUM2+L2
        IF(L1.EQ.L) GOTO 100
      ENDIF
      WRITE(*,*) 'Expansion: ',REAL(SUM2)/REAL(SUM1)
      CALL CLOSEF@(IHANDLE)
      CALL CLOSEF@(OHANDLE)
      
      RETURN
      END
